#!/bin/bash
set -e
set -u

download_url="http://www.unrealsoftware.de/get.php?get"
download_page="http://www.cs2d.com/download.php"

boldprint() {
    echo -e "\033[1m${1}\e[0m"
}

grabversion() {
    echo $(curl "${download_page}" |
            grep -o "get.php?get=cs2d_[0-9]\+_win.zip" | cut -d'_' -f2)
}

# from https://bbs.archlinux.org/viewtopic.php?id=141195
grabcid() {
    local file=cs2d_${version}_linux.zip
    echo "$(curl -Ss "${download_url}=${file}&p=1" |
            grep -o '"get.php[^"]\+"' | cut -d'"' -f2 | sed 's/.\+cid=//g')"
}

getfile() {
    local file=${1}
    local url=${2}

    boldprint "Downloading ${file} from unrealsoftware.de"
    curl -o ${file} ${url}

    boldprint "Extracting ${file}"
    unzip ${file}
}

install() {
    version=$(grabversion)
    boldprint "Got version: ${version}"

    cid=$(grabcid)
    boldprint "Got client id: ${cid}"

    win="cs2d_${version}_win.zip"
    linux="cs2d_${version}_linux.zip"
    dedicated="cs2d_dedicated_linux.zip"

    getfile "${win}" "${download_url}=${win}&p=1&cid=${cid}"
    getfile "${linux}" "${download_url}=${linux}&p=1&cid=${cid}"
    getfile "${dedicated}" "http://www.unrealsoftware.de/files_pub/${dedicated}"

    boldprint "Modifying file permissions"
    chmod +x cs2d_dedicated CounterStrike2D

    boldprint "Removing zip files"
    rm ${win} ${linux} ${dedicated}

    boldprint "Removing Windows-only files"
    rm *.exe *.bat
}

install
